"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantSource(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "aggregation",
        "fileId",
        "metadata",
        "pedigree",
        "studyId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import opencb as opencb_1_3_0

        return {
            "header": opencb_1_3_0.VcfHeader,
            "stats": opencb_1_3_0.VariantGlobalStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.avro.legacy.VcfHeader": opencb_1_3_0.VcfHeader,
            "org.opencb.biodata.models.variant.avro.legacy.VariantGlobalStats": opencb_1_3_0.VariantGlobalStats,
            "org.opencb.biodata.models.variant.avro.legacy.VariantSource": opencb_1_3_0.VariantSource,
        }

    __slots__ = [
        "aggregation",
        "fileId",
        "metadata",
        "pedigree",
        "studyId",
        "fileName",
        "header",
        "samples",
        "stats",
        "studyName",
    ]

    def __init__(
        self,
        aggregation,
        fileId,
        metadata,
        pedigree,
        studyId,
        fileName=None,
        header=None,
        samples=list,
        stats=None,
        studyName=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.VariantSource model.

        :param aggregation:
        :type aggregation: str
        :param fileId:
        :type fileId: str
        :param metadata:
        :type metadata: dict[str, str | VcfHeader]
        :param pedigree:
        :type pedigree: None
        :param studyId:
        :type studyId: str
        :param fileName:
        :type fileName: None | str
        :param header:
        :type header: None | VcfHeader
        :param samples:
        :type samples: list[str]
        :param stats:
        :type stats: None | VariantGlobalStats
        :param studyName:
        :type studyName: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
